package at.jku.ssw.pi.set.tree.ue04a;

import at.jku.ssw.pi.Iterator;
import at.jku.ssw.pi.list.linked.LinkedList;
import at.jku.ssw.pi.util.Out;

class BinaryTreeSetTest {

	public static void main(String[] args) {
		BinaryTreeSet set = createSet(new int[] { 6, 2, 1, 4, 3, 5, 7, 9, 8 });
		makeDot((BinaryTreeSet) set, "tree.dot");
		preOrder(set);
		inOrder(set);
		postOrder(set);
	}

	static void preOrder(BinaryTreeSet set) {
		Out.println("\n*** Pre-Order ***");
		printList(set.getElementsPreOrder());
	}

	static void inOrder(BinaryTreeSet set) {
		Out.println("\n*** In-Order ***");
		printList(set.getElementsInOrder());
	}

	static void postOrder(BinaryTreeSet set) {
		Out.println("\n*** Post-Order ***");
		printList(set.getElementsPostOrder());
	}

	static void printList(LinkedList elementsPreOrder) {
		Iterator iterator = elementsPreOrder.iterator();
		String sep = "";
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		while (iterator.hasNext()) {
			sb.append(sep);
			sb.append(iterator.next());
			sep = ",";
		}
		sb.append("]");
		Out.println(sb.toString());
	}

	static BinaryTreeSet createSet(int[] values) {
		BinaryTreeSet set = new BinaryTreeSet();
		for (int i = 0; i < values.length; i++) {
			set.add(values[i]);
		}
		return set;
	}

	static void makeDot(BinaryTreeSet set, String filename) {
		Out.open(filename);
		Out.print(set.makeDot());
		Out.close();
	}

}