package at.jku.ssw.pi.set.tree.ue04b;

import at.jku.ssw.pi.graphviz.DotMakerTree234;
import at.jku.ssw.pi.tree234.TreeNode234;

/**
 * Implementation of 2-3-4 tree.
 */
public class Tree234 {

	/** The root node of the 2-3-4 tree. */
	private TreeNode234 root;

	public void insert(char value) {
		// TODO
	}

	/**
	 * Splits a full node (= a node with 3 values) into two sub nodes.<br>
	 * The left value (at position 0) and the right value (at position 2) are
	 * put into new nodes.<br>
	 * The middle value (at position 1) is pulled into the parent.<br>
	 * If no parent exists, a new parent is created and returned.
	 *
	 * @param parent
	 *            The parent node of the node to split (may be {@code null}).
	 * @param successorIdx
	 *            The index of the node to split in the parent's successor list
	 *            (must be {@code 0 <= successorIdx < 4}).
	 * @param splitNode
	 *            The node to split (must not be {@code null}; must have 3
	 *            values because only full nodes can be split).
	 * @return The parent node of the split node (will never be {@code null}).
	 */
	private TreeNode234 split(TreeNode234 parent, int successorIdx, TreeNode234 splitNode) {

		if (splitNode.size() != 3) {
			throw new IllegalArgumentException("Cannot split non-full node!");
		}

		TreeNode234 newLeft = new TreeNode234();
		newLeft.insertValue(0, splitNode.getValue(0));
		newLeft.setSuccessor(0, splitNode.getSuccessor(0));
		newLeft.setSuccessor(1, splitNode.getSuccessor(1));

		TreeNode234 newRight = new TreeNode234();
		newRight.insertValue(0, splitNode.getValue(2));
		newRight.setSuccessor(0, splitNode.getSuccessor(2));
		newRight.setSuccessor(1, splitNode.getSuccessor(3));

		// create new parent if no parent exists
		if (parent == null) {
			parent = new TreeNode234();
			successorIdx = 0;
		}

		// insert middle value into parent
		assert parent.size() < 3;
		parent.insertValue(successorIdx, splitNode.getValue(1));
		parent.setSuccessor(successorIdx, newLeft);
		parent.setSuccessor(successorIdx + 1, newRight);
		return parent;
	}

	public String makeDot() {
		return new DotMakerTree234(root).getDot();
	}
}
